Index: lemon/list_graph.h
===================================================================
--- lemon/list_graph.h	(revision 1956)
+++ lemon/list_graph.h	(revision 1979)
@@ -24,14 +24,9 @@
 ///\brief ListGraph, ListUGraph classes.
 
-#include <lemon/bits/erasable_graph_extender.h>
-#include <lemon/bits/clearable_graph_extender.h>
-#include <lemon/bits/extendable_graph_extender.h>
-#include <lemon/bits/iterable_graph_extender.h>
-#include <lemon/bits/alteration_notifier.h>
-#include <lemon/bits/default_map.h>
 #include <lemon/bits/graph_extender.h>
 
 #include <lemon/error.h>
 
+#include <vector>
 #include <list>
 
@@ -312,11 +307,5 @@
   };
 
-  typedef ErasableGraphExtender<
-    ClearableGraphExtender<
-    ExtendableGraphExtender<
-    MappableGraphExtender<
-    IterableGraphExtender<
-    AlterableGraphExtender<
-    GraphExtender<ListGraphBase> > > > > > > ExtendedListGraphBase;
+  typedef GraphExtender<ListGraphBase> ExtendedListGraphBase;
 
   /// \addtogroup graphs
@@ -579,11 +568,6 @@
   /**************** Undirected List Graph ****************/
 
-  typedef ErasableUGraphExtender<
-    ClearableUGraphExtender<
-    ExtendableUGraphExtender<
-    MappableUGraphExtender<
-    IterableUGraphExtender<
-    AlterableUGraphExtender<
-    UGraphExtender<ListGraphBase> > > > > > > ExtendedListUGraphBase;
+  typedef UGraphExtender<UGraphBaseExtender<
+    ListGraphBase> > ExtendedListUGraphBase;
 
   /// \addtogroup graphs
Index: lemon/prim.h
===================================================================
--- lemon/prim.h	(revision 1956)
+++ lemon/prim.h	(revision 1979)
@@ -789,5 +789,5 @@
     prm.treeMap(tree);
     prm.run();
-  };
+  }
 
 } //END OF NAMESPACE LEMON
Index: lemon/radix_sort.h
===================================================================
--- lemon/radix_sort.h	(revision 1956)
+++ lemon/radix_sort.h	(revision 1979)
@@ -265,5 +265,5 @@
     const int size = 
       (unsigned int)std::numeric_limits<unsigned char>::max() + 1;
-    int counter[size];
+    std::vector<int> counter(size);
     for (int i = 0; i < size; ++i) {
       counter[i] = 0;
@@ -291,5 +291,5 @@
     const int size = 
       (unsigned int)std::numeric_limits<unsigned char>::max() + 1;
-    int counter[size];
+    std::vector<int> counter(size);
     for (int i = 0; i < size; ++i) {
       counter[i] = 0;
Index: lemon/smart_graph.h
===================================================================
--- lemon/smart_graph.h	(revision 1956)
+++ lemon/smart_graph.h	(revision 1979)
@@ -28,13 +28,10 @@
 #include <lemon/invalid.h>
 
-#include <lemon/bits/clearable_graph_extender.h>
-#include <lemon/bits/extendable_graph_extender.h>
-#include <lemon/bits/iterable_graph_extender.h>
-#include <lemon/bits/alteration_notifier.h>
-#include <lemon/bits/default_map.h>
 #include <lemon/bits/graph_extender.h>
 
 #include <lemon/utility.h>
 #include <lemon/error.h>
+
+#include <lemon/bits/graph_extender.h>
 
 namespace lemon {
@@ -223,10 +220,5 @@
   };
 
-  typedef ClearableGraphExtender<
-    ExtendableGraphExtender<
-    MappableGraphExtender<
-    IterableGraphExtender<
-    AlterableGraphExtender<
-    GraphExtender<SmartGraphBase> > > > > > ExtendedSmartGraphBase;
+  typedef GraphExtender<SmartGraphBase> ExtendedSmartGraphBase;
 
   /// \ingroup graphs
@@ -245,5 +237,7 @@
   class SmartGraph : public ExtendedSmartGraphBase {
   public:
-    
+
+    typedef ExtendedSmartGraphBase Parent;
+
     class Snapshot;
     friend class Snapshot;
@@ -356,10 +350,6 @@
   /**************** Undirected List Graph ****************/
 
-  typedef ClearableUGraphExtender<
-    ExtendableUGraphExtender<
-    MappableUGraphExtender<
-    IterableUGraphExtender<
-    AlterableUGraphExtender<
-    UGraphExtender<SmartGraphBase> > > > > > ExtendedSmartUGraphBase;
+  typedef UGraphExtender<UGraphBaseExtender<SmartGraphBase> >
+  ExtendedSmartUGraphBase;
 
   /// \ingroup graphs
@@ -588,12 +578,6 @@
 
 
-  typedef ClearableBpUGraphExtender<
-    ExtendableBpUGraphExtender<
-    MappableBpUGraphExtender<
-    IterableBpUGraphExtender<
-    AlterableBpUGraphExtender<
-    BpUGraphExtender <
-    SmartBpUGraphBase> > > > > >
-  ExtendedSmartBpUGraphBase;
+  typedef BpUGraphExtender< BpUGraphBaseExtender<
+    SmartBpUGraphBase> > ExtendedSmartBpUGraphBase;
 
   /// \ingroup graphs
Index: lemon/sub_graph.h
===================================================================
--- lemon/sub_graph.h	(revision 1964)
+++ lemon/sub_graph.h	(revision 1979)
@@ -387,7 +387,7 @@
   template <typename Graph>
   class SubGraph 
-    : public IterableGraphExtender< SubGraphBase<Graph> > {
+    : public GraphAdaptorExtender< SubGraphBase<Graph> > {
   public:
-    typedef IterableGraphExtender< SubGraphBase<Graph> > Parent;
+    typedef GraphAdaptorExtender< SubGraphBase<Graph> > Parent;
   public:
     /// \brief Constructor for sub-graph.
@@ -684,7 +684,7 @@
   template <typename Graph>
   class EdgeSubGraph 
-    : public IterableGraphExtender< EdgeSubGraphBase<Graph> > {
+    : public GraphAdaptorExtender< EdgeSubGraphBase<Graph> > {
   public:
-    typedef IterableGraphExtender< EdgeSubGraphBase<Graph> > Parent;
+    typedef GraphAdaptorExtender< EdgeSubGraphBase<Graph> > Parent;
   public:
     /// \brief Constructor for sub-graph.
Index: lemon/topology.h
===================================================================
--- lemon/topology.h	(revision 1956)
+++ lemon/topology.h	(revision 1979)
@@ -1418,5 +1418,5 @@
     }
     return true;
-  };
+  }
   
   /// \ingroup topology
@@ -1460,5 +1460,5 @@
     }
     return true;
-  };
+  }
    
 } //namespace lemon
Index: lemon/traits.h
===================================================================
--- lemon/traits.h	(revision 1956)
+++ lemon/traits.h	(revision 1979)
@@ -210,4 +210,17 @@
   };
 
+  template <typename Graph, typename Enable = void>
+  struct UndirectedTagIndicator {
+    static const bool value = false;
+  };
+
+  template <typename Graph>
+  struct UndirectedTagIndicator<
+    Graph, 
+    typename enable_if<typename Graph::UndirectedTag, void>::type
+  > {
+    static const bool value = true;
+  };
+
 
 
